{{ DelayGenerator.spin }}
'Copyright 2007 Raymond Allen

VAR

  long cog


PUB Start(pInput): okay 
{{Load Delay Generator into a new cog.}}

  stop  'I guess make sure not already loaded
  'longmove(@par_keys, @dpin, 4)
  okay := cog := cognew(@DelayGen, pInput) + 1


PUB stop

'' Stop keyboard driver - frees a cog

  if cog
    cogstop(cog~ -  1)
      
CON
        LoopDelay=80 'clocks=1us
DAT
        ORG 0
DelayGen
'load 14 input parameters from hub to cog given address in par
        movd    :par,#OPinA             
        mov     x,par
        mov     y,#14
:par    rdlong  0,x
        add     :par,dlsb
        add     x,#4
        djnz    y,#:par

'sync timing with any other generators
        WAITCNT SyncCNT,#0

'initialize variables                      
        MOV PinsOut, #$00 '(Cell 1) Initialize output parameter
        MOV OUTA, PinsOut  'init output
        
        'Set output pins:  1st bit of OPinX indicates 1=disabled, 0=enabled
        CMP OPinA,#32 wz,wc
        IF_AE JMP #endDirA        
        MOV DMaskA,#1
        ROL DMaskA,OPinA
        OR DIRA, DMaskA
endDirA        
        CMP OPinB,#32 wz,wc
        IF_AE JMP #endDirB
        MOV DMaskB,#1
        ROL DMaskB,OPinB
        OR DIRA, DMaskB
endDirB        
        CMP OPinC,#32 wz,wc
        IF_AE JMP #endDirC
        MOV DMaskC,#1
        ROL DMaskC,OPinC
        OR DIRA, DMaskC
endDirC        
        CMP OPinT0,#32 wz,wc
        IF_AE JMP #endDirT0
        MOV DMaskT0,#1
        ROL DMaskT0,OPinT0
        OR DIRA, DMaskT0
endDirT0


        'reference width to beginning of pulse
        ADD WidthA, DelayA
        ADD WidthB, DelayB
        ADD WidthC, DelayC
        
        'need to correct for loop delay
        'loop is 20 instructions ->80 clocks =1000 ns
        SUB Period,#LoopDelay

WaitTrigger    'wait for specified trigger pin to go high
        CMP IPinTrig,#32  wz,wc
        IF_AE JMP #InitClock
        MOV DMaskTrig,#1
        ROL DMaskTrig,IPinTrig
        ROL StartCNT,#1  wc 'clear carry flag
        WAITPEQ DMaskTrig,DMaskTrig 

InitClock
        'get initial clock time
        MOV StartCNT,CNT
        
        'Start period loop
CycleLoop
        NOP   'to syncronize cycle and burst loops
        NOP     
BurstLoop
        MOV PinsOut, DMaskT0 '#$00  're-init output pattern
        
        MOV thisCNT, CNT 'get current clock time
        SUB thisCNT, StartCNT  'calc offset from period start time
        'see if it is time to start pulse
        CMP thisCNT, DelayA wz, wc
        IF_AE OR PinsOut,DMaskA
        CMP thisCNT, DelayB wz, wc
        IF_AE OR PinsOut,DMaskB
        CMP thisCNT, DelayC wz, wc
        IF_AE OR PinsOut,DMaskC
        'see if time to end pulse
        CMP thisCNT,WidthA wz, wc
        IF_AE XOR PinsOut,DMaskA
        CMP thisCNT,WidthB wz, wc
        IF_AE XOR PinsOut,DMaskB
        CMP thisCNT,WidthC wz, wc
        IF_AE XOR PinsOut,DMaskC
        'output pattern
        MOV OUTA, PinsOut  

        'see if time to end period
        CMP thisCNT,Period wz, wc
        IF_B JMP #CycleLoop

        'start new period
        MOV StartCNT, CNT
        DJNZ NBurst,#BurstLoop 

        'wait to make up a loop time from last OUTA to this next OUTA
        'need 14 instructions  (last DJNZ loop counts as 2!)
        MOV x,#6
:loop   NOP
        DJNZ x,#:loop        

        
        'end of periods, reset output
        MOV OUTA,#0
        MOV DIRA,#0
          
End
        'now stop
        COGID thisCog1
        COGSTOP thisCog1   

'variables for loading parameters (from keyboard.spin)        
x       long 0
y       long 0        
dlsb    long    1 << 9 
'Working variables        
PinsOut LONG $AAAAAAAA '(Cell 5)
StartCNT   LONG 0
thisCNT LONG 0
'Cycle   LONG 0
thisCog1 LONG 5  '0=SPIN, 1=keyboard, 2=mouse, 3=VGA, 4=VGA, 5=This
DMaskA  LONG 1
DMaskB  Long 1
DMaskC  Long 1
DMaskT0 Long 1
DMaskTrig Long 1
'input parameters
OPinA   LONG 7
OPinB   Long 6
OPinC   Long 4
OPinT0  Long 5        'Pin# of T0
IPinTrig Long 0
DelayA  LONG 0'LoopDelay*2
DelayB  LONG LoopDelay*55
DelayC  LONG LoopDelay*2
WidthA  LONG LoopDelay*54
WidthB  LONG LoopDelay*54
WidthC  LONG LoopDelay*3
Period  LONG LoopDelay*110 '320
NBurst  LONG 3
SyncCNT Long 0


        FIT 496  